---
title: Debugger.Source
slug: Tools/Debugger-API/Debugger.Source
---
<div>{{ToolsSidebar}}</div><h1 id="Debugger.Source">Debugger.Source</h1>

<p>A <code>Debugger.Source</code> instance represents either a piece of JavaScript source code or the serialized text of a block of WebAssembly code. The two cases are distinguished by the latter having its <code>introductionType</code> property always being <code>"wasm"</code> and the former having its <code>introductionType</code> property never being <code>"wasm"</code>.</p>

<p>Each <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instance has a separate collection of <code>Debugger.Source</code> instances representing the source code that has been presented to the system.</p>

<p>A debugger may place its own properties on <code>Debugger.Source</code> instances, to store metadata about particular pieces of source code.</p>

<h2 id="Debugger.Source_for_JavaScript">Debugger.Source for JavaScript</h2>

<p>For a <code>Debugger.Source</code> instance representing a piece of JavaScript source code, its properties provide the source code itself as a string, and describe where it came from. Each <a href="Debugger.Script"><code>Debugger.Script</code></a> instance refers to the <code>Debugger.Source</code> instance holding the source code from which it was produced.</p>

<p>If a single piece of source code contains both top-level code and function definitions, perhaps with nested functions, then the <a href="Debugger.Script"><code>Debugger.Script</code></a> instances for those all refer to the same <code>Debugger.Source</code> instance. Each script indicates the substring of the overall source to which it corresponds.</p>

<p>A <code>Debugger.Source</code> instance may represent only a portion of a larger source document. For example, an HTML document can contain JavaScript in multiple <code>&lt;script&gt;</code> elements and event handler content attributes. In this case, there may be either a single <code>Debugger.Source</code> instance for the entire HTML document, with each <a href="Debugger.Script"><code>Debugger.Script</code></a> referring to its substring of the document; or there may be a separate <code>Debugger.Source</code> instance for each <code>&lt;script&gt;</code> element and attribute. The choice is left up to the implementation.</p>

<p>If a given piece of source code is presented to the JavaScript implementation more than once, with the same origin metadata, the JavaScript implementation may generate a fresh <code>Debugger.Source</code> instance to represent each presentation, or it may use a single <code>Debugger.Source</code> instance to represent them all.</p>

<h2 id="Debugger.Source_for_WebAssembly">Debugger.Source for WebAssembly</h2>

<p>For a <code>Debugger.Source</code> instance representing the serialized text of a block of WebAssembly code, its properties provide the serialized text as a string.</p>

<p>Currently only entire modules evaluated via <code>new WebAssembly.Module</code> are represented. SpiderMonkey constructs exactly one <code>Debugger.Source</code> for each underlying WebAssembly module per <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instance.</p>

<p>Please note at the time of this writing, support for WebAssembly is very preliminary. Many properties below return placeholder values.</p>

<h2 id="Convention">Convention</h2>

<p>For descriptions of properties and methods below, if the behavior of the property or method differs between the instance referring to JavaScript source or to a block of WebAssembly code, the text will be split into two sections, headed by “<strong>if the instance refers to JavaScript source</strong>” and “<strong>if the instance refers to WebAssembly code</strong>”, respectively. If the behavior does not differ, no such emphasized headings will appear.</p>

<h2 id="Accessor_Properties_of_the_Debugger.Source_Prototype_Object">Accessor Properties of the Debugger.Source Prototype Object</h2>

<p>A <code>Debugger.Source</code> instance inherits the following accessor properties from its prototype:</p>

<dl>
 <dt><code>text</code></dt>
 <dd>
 <p><strong>If the instance refers to JavaScript source</strong>, the JavaScript source code, as a string. The value satisfies the <code>Program</code>, <code>FunctionDeclaration</code>, or <code>FunctionExpression</code> productions in the ECMAScript standard.</p>

 <p><strong>If the instance refers to WebAssembly code</strong>, the serialized text representation. The format is yet to be specified in the WebAssembly standard. Currently, the text is an s-expression based syntax. The text generation is disabled if the Debugger has the <code>allowWasmBinarySource</code> property set, the <code>"[wasm]"</code> value will be returned in this case.</p>
 </dd>
 <dt><code>binary</code></dt>
 <dd><strong>If the instance refers to WebAssembly code</strong> and the Debugger has the <code>allowWasmBinarySource</code> property set, a Uint8Array that contains the WebAssembly bytecode.</dd>
 <dt><code>url</code></dt>
 <dd>
 <p><strong>If the instance refers to JavaScript source</strong>, the filename or URL from which this script’s code was loaded. For scripts created by <code>eval</code> or the <code>Function</code> constructor, this may be a synthesized filename, starting with a valid URL and followed by information tracking how the code was introduced into the system; the entire string is not a valid URL. For <code>Function.prototype</code>’s script, this is <code>null</code>. Source may be loaded from a URL in the following ways:</p>

 <ul>
  <li>
   <p>The URL may appear as the <code>src</code> attribute of a <code>&lt;script&gt;</code> element in markup text.</p>
  </li>
  <li>
   <p>The URL may be passed to the <code>Worker</code> web worker constructor, or the web worker <code>importScripts</code> function.</p>
  </li>
  <li>
   <p>The URL may be the name of a XPCOM JavaScript module or subscript.</p>
  </li>
 </ul>

 <p>(Note that code passed to <code>eval</code>, the <code>Function</code> constructor, or a similar function is<em>not</em> considered to be loaded from a URL; the <code>url</code> accessor on <code>Debugger.Source</code> instances for such sources should return <code>undefined</code>.)</p>

 <p><strong>If the instance refers to WebAssembly code</strong>, the URL of the script that called <code>new WebAssembly.Module</code> with the string <code>"&gt; wasm"</code> appended.</p>
 </dd>
 <dt><code>sourceMapURL</code></dt>
 <dd>
 <p><strong>If the instance refers to JavaScript source</strong>, if this source was produced by a minimizer or translated from some other language, and we know the URL of a <strong>source map</strong> document relating the source positions in this source to the corresponding source positions in the original source, then this property’s value is that URL. Otherwise, this is <code>null</code>.</p>

 <p>(On the web, the translator may provide the source map URL in a specially formatted comment in the JavaScript source code, or via a header in the HTTP reply that carried the generated JavaScript.)</p>

 <p>This property is writable, so you can change the source map URL by setting it. All Debugger.Source objects referencing the same source will see the change. Setting an empty string has no effect and will not change existing value.</p>

 <p><strong>If the instance refers to WebAssembly code</strong>, <code>null</code>. Attempts to write to this property throw a <code>TypeError</code>.</p>
 </dd>
 <dt><code>displayURL</code></dt>
 <dd>If the script had a special <code>//# sourceURL</code> comment, as described in the source maps specification, then this property’s value holds the string that was given. Otherwise, this is <code>null</code>.</dd>
 <dt><code>element</code></dt>
 <dd>
 <p>The <a href="Debugger.Object"><code>Debugger.Object</code></a> instance referring to the DOM element to which this source code belongs, if any, or <code>undefined</code> if it belongs to no DOM element. Source belongs to a DOM element in the following cases:</p>

 <ul>
  <li>
   <p>Source belongs to a <code>&lt;script&gt;</code> element if it is the element’s text content (that is, it is written out as the body of the <code>&lt;script&gt;</code> element in the markup text), or is the source document referenced by its <code>src</code> attribute.</p>
  </li>
  <li>
   <p>Source belongs to a DOM element if it is an event handler content attribute (that is, if it is written out in the markup text as an attribute value).</p>
  </li>
  <li>
   <p>Source belongs to a DOM element if it was assigned to one of the element’s event handler IDL attributes as a string. (Note that one may assign both strings and functions to DOM elements’ event handler IDL attributes. If one assigns a function, that function’s script’s source does<em>not</em> belong to the DOM element; the function’s definition must appear elsewhere.)</p>
  </li>
 </ul>

 <p>(If the sources attached to a DOM element change, the <code>Debugger.Source</code> instances representing superceded code still refer to the DOM element; this accessor only reflects origins, not current relationships.)</p>
 </dd>
 <dt><code>elementAttributeName</code></dt>
 <dd>If this source belongs to a DOM element because it is an event handler content attribute or an event handler IDL attribute, this is the name of that attribute, a string. Otherwise, this is <code>undefined</code>.</dd>
 <dt><code>introductionType</code></dt>
 <dd>
 <p><strong>If the instance refers to JavaScript source</strong>, a string indicating how this source code was introduced into the system. This accessor returns one of the following values:</p>

 <ul>
  <li>
   <p><code>"eval"</code>, for code passed to <code>eval</code>.</p>
  </li>
  <li>
   <p><code>"Function"</code>, for code passed to the <code>Function</code> constructor.</p>
  </li>
  <li>
   <p><code>"Function.prototype"</code>, for <code>Function.prototype</code> internally generated code.</p>
  </li>
  <li>
   <p><code>"Worker"</code>, for code loaded by calling the Web worker constructor—the worker’s main script.</p>
  </li>
  <li>
   <p><code>"importScripts"</code>, for code by calling <code>importScripts</code> in a web worker.</p>
  </li>
  <li>
   <p><code>"eventHandler"</code>, for code assigned to DOM elements’ event handler IDL attributes as a string.</p>
  </li>
  <li>
   <p><code>"scriptElement"</code>, for code belonging to <code>&lt;script&gt;</code> elements.</p>
  </li>
  <li>
   <p><code>"javascriptURL"</code>, for code presented in <code>javascript:</code> URLs.</p>
  </li>
  <li>
   <p><code>"setTimeout"</code>, for code passed to <code>setTimeout</code> as a string.</p>
  </li>
  <li>
   <p><code>"setInterval"</code>, for code passed to <code>setInterval</code> as a string.</p>
  </li>
  <li>
   <p><code>undefined</code>, if the implementation doesn’t know how the code was introduced.</p>
  </li>
 </ul>

 <p><strong>If the instance refers to WebAssembly code</strong>, <code>"wasm"</code>.</p>
 </dd>
 <dt><code>introductionScript</code>, <code>introductionOffset</code></dt>
 <dd>
 <p><strong>If the instance refers to JavaScript source</strong>, and if this source was introduced by calling a function from debuggee code, then <code>introductionScript</code> is the <a href="Debugger.Script"><code>Debugger.Script</code></a> instance referring to the script containing that call, and <code>introductionOffset</code> is the call’s bytecode offset within that script. Otherwise, these are both <code>undefined</code>. Taken together, these properties indicate the location of the introducing call.</p>

 <p>For the purposes of these accessors, assignments to accessor properties are treated as function calls. Thus, setting a DOM element’s event handler IDL attribute by assigning to the corresponding JavaScript property creates a source whose <code>introductionScript</code> and <code>introductionOffset</code> refer to the property assignment.</p>

 <p>Since a <code>&lt;script&gt;</code> element parsed from a web page’s original HTML was not introduced by any scripted call, its source’s <code>introductionScript</code> and <code>introductionOffset</code> accessors both return <code>undefined</code>.</p>

 <p>If a <code>&lt;script&gt;</code> element was dynamically inserted into a document, then these accessors refer to the call that actually caused the script to run—usually the call that made the element part of the document. Thus, they do<em>not</em> refer to the call that created the element; stored the source as the element’s text child; made the element a child of some uninserted parent node that was later inserted; or the like.</p>

 <p>Although the main script of a worker thread is introduced by a call to <code>Worker</code> or <code>SharedWorker</code>, these accessors always return <code>undefined</code> on such script’s sources. A worker’s main script source and the call that created the worker are always in separate threads, but <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> is an inherently single-threaded facility: its debuggees must all run in the same thread. Since the global that created the worker is in a different thread, it is guaranteed not to be a debuggee of the <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instance that owns this source; and thus the creating call is never “in debuggee code”. Relating a worker to its creator, and other multi-threaded debugging concerns, are out of scope for <a href="Debugger" title="The Debugger object"><code>Debugger</code></a>.</p>

 <p><strong>If the instance refers to WebAssembly code</strong>, <code>introductionScript</code> is the <a href="Debugger.Script"><code>Debugger.Script</code></a> instance referring to the same underlying WebAssembly module. <code>introductionOffset</code> is <code>undefined</code>.</p>
 </dd>
</dl>

<h4 id="Source_Metadata">Source Metadata</h4>

<dl>
 <dt>Generated from file:</dt>
 <dt> </dt>
 <dd>js/src/doc/Debugger/Debugger.Source.md</dd>
 <dt>Watermark:</dt>
 <dd id="watermark">sha256:5ca245813db96628aab1c78b803355eb2aa8c575839c67eb7d7bde177898df88</dd>
 <dt>Changeset:</dt>
 <dd><a href="https://hg.mozilla.org/mozilla-central/rev/e91b2c85aacd">e91b2c85aacd</a></dd>
</dl>
